import typer

app = typer.Typer(no_args_is_help=True)


@app.command()
def list():
    """List all workflows"""
    from knoc.workflows import all_wfs

    typer.echo("\n".join([wf.name for wf in all_wfs]))


@app.command()
def run(name: str):
    """Run a workflow"""
    from knoc.workflows import all_wfs

    wf_dict = {wf.name: wf for wf in all_wfs}
    if name not in wf_dict:
        typer.echo(f"Unknown workflow {name}. Use 'list' to view all workflows")
        raise typer.Exit(1)
    wf = wf_dict[name]
    result = wf.run()  # type: ignore
    typer.echo(result)
