import logging
from importlib.metadata import entry_points

from hatchet_sdk.runnables.workflow import Workflow

from knoc.workflows.foo import foo_wf

logger = logging.getLogger("knoc.workflows")

all_wfs = [foo_wf]


def get_plugins(workflows: list[Workflow]):
    for entry_point in entry_points().select(group="knoc.workflow"):
        try:
            wf = entry_point.load()
        except Exception as err:
            logger.warning(f"Cannot load CLI module {entry_point.name} - see below")
            logger.exception(err)
            continue
        if not isinstance(wf, Workflow):
            logger.warning(f"CLI module {entry_point.name} is not a Typer")
            continue
        workflows.append(wf)


get_plugins(all_wfs)
