from datetime import datetime
from pydantic import BaseModel
from hatchet_sdk import Context, EmptyModel

from knoc.hatchet_client import hatchet
from knoc import __version__


class SimpleOutput(BaseModel):
    message: str


foo_wf = hatchet.workflow(
    name="Foo",
    description="Does nothing else but give time",
    input_validator=EmptyModel,
    version=__version__,
)


@foo_wf.task()
async def foo_task(input: EmptyModel, ctx: Context) -> SimpleOutput:
    ctx.log("Foo!")
    return SimpleOutput(message=f"Foo v{__version__} at {datetime.now()}")
